# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import _utilities, _tables


class DnsZone(pulumi.CustomResource):
    activation_state: pulumi.Output[str]
    alias_count: pulumi.Output[float]
    comment: pulumi.Output[str]
    """
    — (Required) A descriptive comment.
    """
    contract: pulumi.Output[str]
    """
    — (Required) The contract ID.
    """
    end_customer_id: pulumi.Output[str]
    """
    — (Optional)
    """
    group: pulumi.Output[str]
    """
    — (Required) The currently selected group ID.
    """
    masters: pulumi.Output[list]
    """
    — (Required for Secondary) The names or addresses of the customer’s nameservers from which the zone data should be retrieved.
    """
    sign_and_serve: pulumi.Output[bool]
    """
    — (Optional) Whether DNSSEC Sign&Serve is enabled.
    """
    sign_and_serve_algorithm: pulumi.Output[str]
    """
    — (Optional) Algorithm used by Sign&Serve.
    """
    target: pulumi.Output[str]
    """
    — (Required for Alias)
    """
    tsig_key: pulumi.Output[dict]
    """
    — (Optional) TSIG Key used in secure zone transfers

      * `algorithm` (`str`)
      * `name` (`str`) - key name
        * `algorithm`
        * `secret`
      * `secret` (`str`)
    """
    type: pulumi.Output[str]
    """
    — (Required) Whether the zone is primary or secondary.
    """
    version_id: pulumi.Output[str]
    zone: pulumi.Output[str]
    """
    — (Required) Domain zone, encapsulating any nested subdomains.
    """
    def __init__(__self__, resource_name, opts=None, comment=None, contract=None, end_customer_id=None, group=None, masters=None, sign_and_serve=None, sign_and_serve_algorithm=None, target=None, tsig_key=None, type=None, zone=None, __props__=None, __name__=None, __opts__=None):
        """
        The `edgedns.DnsZone` provides the resource for configuring a dns zone to integrate easily with your existing DNS infrastructure to provide a secure, high performance, highly available and scalable solution for DNS hosting.

        ## Example Usage
        ### Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        demozone = akamai.edgedns.DnsZone("demozone",
            comment="some comment",
            contract="ctr_XXX",
            group=100,
            masters=[
                "1.2.3.4",
                "1.2.3.5",
            ],
            sign_and_serve=False,
            type="secondary",
            zone="example.com")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] comment: — (Required) A descriptive comment.
        :param pulumi.Input[str] contract: — (Required) The contract ID.
        :param pulumi.Input[str] end_customer_id: — (Optional)
        :param pulumi.Input[str] group: — (Required) The currently selected group ID.
        :param pulumi.Input[list] masters: — (Required for Secondary) The names or addresses of the customer’s nameservers from which the zone data should be retrieved.
        :param pulumi.Input[bool] sign_and_serve: — (Optional) Whether DNSSEC Sign&Serve is enabled.
        :param pulumi.Input[str] sign_and_serve_algorithm: — (Optional) Algorithm used by Sign&Serve.
        :param pulumi.Input[str] target: — (Required for Alias)
        :param pulumi.Input[dict] tsig_key: — (Optional) TSIG Key used in secure zone transfers
        :param pulumi.Input[str] type: — (Required) Whether the zone is primary or secondary.
        :param pulumi.Input[str] zone: — (Required) Domain zone, encapsulating any nested subdomains.

        The **tsig_key** object supports the following:

          * `algorithm` (`pulumi.Input[str]`)
          * `name` (`pulumi.Input[str]`) - key name
            * `algorithm`
            * `secret`
          * `secret` (`pulumi.Input[str]`)
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['comment'] = comment
            if contract is None:
                raise TypeError("Missing required property 'contract'")
            __props__['contract'] = contract
            __props__['end_customer_id'] = end_customer_id
            if group is None:
                raise TypeError("Missing required property 'group'")
            __props__['group'] = group
            __props__['masters'] = masters
            __props__['sign_and_serve'] = sign_and_serve
            __props__['sign_and_serve_algorithm'] = sign_and_serve_algorithm
            __props__['target'] = target
            __props__['tsig_key'] = tsig_key
            if type is None:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            if zone is None:
                raise TypeError("Missing required property 'zone'")
            __props__['zone'] = zone
            __props__['activation_state'] = None
            __props__['alias_count'] = None
            __props__['version_id'] = None
        super(DnsZone, __self__).__init__(
            'akamai:edgedns/dnsZone:DnsZone',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, activation_state=None, alias_count=None, comment=None, contract=None, end_customer_id=None, group=None, masters=None, sign_and_serve=None, sign_and_serve_algorithm=None, target=None, tsig_key=None, type=None, version_id=None, zone=None):
        """
        Get an existing DnsZone resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] comment: — (Required) A descriptive comment.
        :param pulumi.Input[str] contract: — (Required) The contract ID.
        :param pulumi.Input[str] end_customer_id: — (Optional)
        :param pulumi.Input[str] group: — (Required) The currently selected group ID.
        :param pulumi.Input[list] masters: — (Required for Secondary) The names or addresses of the customer’s nameservers from which the zone data should be retrieved.
        :param pulumi.Input[bool] sign_and_serve: — (Optional) Whether DNSSEC Sign&Serve is enabled.
        :param pulumi.Input[str] sign_and_serve_algorithm: — (Optional) Algorithm used by Sign&Serve.
        :param pulumi.Input[str] target: — (Required for Alias)
        :param pulumi.Input[dict] tsig_key: — (Optional) TSIG Key used in secure zone transfers
        :param pulumi.Input[str] type: — (Required) Whether the zone is primary or secondary.
        :param pulumi.Input[str] zone: — (Required) Domain zone, encapsulating any nested subdomains.

        The **tsig_key** object supports the following:

          * `algorithm` (`pulumi.Input[str]`)
          * `name` (`pulumi.Input[str]`) - key name
            * `algorithm`
            * `secret`
          * `secret` (`pulumi.Input[str]`)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["activation_state"] = activation_state
        __props__["alias_count"] = alias_count
        __props__["comment"] = comment
        __props__["contract"] = contract
        __props__["end_customer_id"] = end_customer_id
        __props__["group"] = group
        __props__["masters"] = masters
        __props__["sign_and_serve"] = sign_and_serve
        __props__["sign_and_serve_algorithm"] = sign_and_serve_algorithm
        __props__["target"] = target
        __props__["tsig_key"] = tsig_key
        __props__["type"] = type
        __props__["version_id"] = version_id
        __props__["zone"] = zone
        return DnsZone(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop
